/** -*-c++-*-
 * Author: Antonio Cisternino
 * Last Update: 1/02/2001
 * Version: 0.3
 */

namespace Command;

var @@currDir = "";

function Reader() {
  // Read line
  var r = trim(stdin.ReadLine());

  if (r == "exit")
    return r;
  else if (r.substring(0, 8) == "setMode ") {
    return "setMode(\"" + trim(r.substring(8)) + "\");";
  }

  // Handle the cd command
  if (r.substring(0, 3) == "cd ") {
    var d = trim(r.substring(3));
    if ((d.charAt(0) == "\\") || (d.charAt(1) == ":")) {
      var dob = fso.GetFolder(d);
      d = dob.Path;
    } else {
      var dob = fso.GetFolder(@@currDir + "\\" + d);
      d = dob.Path;
    }

    if (fso.FolderExists(d))
      @@currDir = d;
    else 
      stdout.write("Directory "+d+" not found.\n");
    
    return "0";
  }

  // Handle the pwd command
  if ((/^\s*pwd\s*$/).test(r)) {
    return "\"" + @@currDir.replace(/\\/g,"\\\\") + "\"";
  }
  
  return "console.run(\"cmd /c "+r+"\", @@currDir);";
}

//////////////////////////////////////////////////////////////////////
// Module registration
//////////////////////////////////////////////////////////////////////

addMode("Command", "Shell mode is a command mode.");
