/** -*-c++-*-
 * Author: Antonio Cisternino
 * Last Update: 6/04/2001
 * Version: 0.3
 */

namespace Directory;

var @@ldap = null;
var @@pwd  = "";
var @@user = "";
var @@currPath = "";
var @@currServer = "";

function Reader() {
  // Read line
  var r = trim(stdin.ReadLine());

  if (r == "exit")
    return r;
  else if (r.substring(0, 8) == "setMode ") {
    return "setMode(\"" + trim(r.substring(8)) + "\");";
  }

  // Handle the cd command
  if (r.substring(0, 3) == "cd ") {
    var d = trim(r.substring(3));

    d = d.replace(/\//g, ",");
    if (d.charAt(0) != ",") {
      d = d + "," + @@currPath;
    } else {
      d = d.substring(1);
    }

    d = d.replace(/\.\.,.*?,/g, ",");
    d = d.replace(/\.,/g, "");

    @@currPath = d;
    
    return "0";
  }

  // Handle the pwd command
  if ((/^\s*pwd\s*$/).test(r)) {
    return "\"" + @@currPath.replace(/\\/g,"\\\\") +","+ @@currDomain + "\"";
  }

  if ((/^\s*setDomain\s+(.*)/).test(r)) {
    var arg = RegExp.$1;
    var ret = "::Directory::SetDomain(\""+arg+"\")";
    return ret;
  } 

  if (r == "dir")
    return "::Directory::dir()";
  
  return "\"Not yet implemented\"";
}

function SetDomain(dom) {
  if ((/^([^\/]+)\/(.*)/).test(dom)) {
    @@currServer = RegExp.$1;
    dom = RegExp.$2;

    stdout.Write("Username: ");
    @@user = stdin.ReadLine();
    stdout.Write("Password: ");
    @@pwd  = readPassword();

    @@ldap = GetObject("LDAP:");
  }
  
  dom = dom.replace(/\./g, ",dc=");
  @@currDomain = "dc=" + dom;
  @@currPath   = "cn=Users";

  return @@currPath + "," + @@currDomain;
}

function dir() {
  var cont;
  if (@@currServer == "")
    cont = GetObject("LDAP://"+@@currPath+","+@@currDomain);
  else
    cont = @@ldap.OpenDSObject("LDAP://" + @@currServer + "/" + @@currPath+","+@@currDomain, @@user, @@pwd, 1);
  
  var e = new Enumerator(cont);
  var ret = "";

  for (; !e.atEnd(); e.moveNext()) {
    var item = e.item();
    ret += item.Get("cn") + "\n";
  }

  return ret;
}

//////////////////////////////////////////////////////////////////////
// Module registration
//////////////////////////////////////////////////////////////////////

addMode("Directory", "Directory reader allow to interact with AD likewise a filesystem.");
