/** -*-c++-*-
 * Author: Antonio Cisternino
 * Last Update: 20/04/2001
 * Version: 0.4
 */

namespace Object;

var @@bracesCount = 0;

function Reader() {
  var r, cmdBuf = "";

  do {
    // Read line
    var r = trim(stdin.ReadLine());

    if (r.indexOf("=") != -1)
      @@addVariable(r);

    @@countBraces(r);
    
    cmdBuf += r;
    if (@@bracesCount) 
      r += "\n";
  } while(@@bracesCount);

  if (cmdBuf == "set")
    cmdBuf = "@@listVariables()";
  else if (/^\s*load\s*\(([^\)]+)\)/.test(cmdBuf))
    cmdBuf = "eval(fimport(" + RegExp.$1 + "))";

  return cmdBuf;
}

function countBraces(s) {
  var i = 0;

  for (i = 0; i < s.length; i++)
    if (s.charAt(i) == "{")
      ++@@bracesCount;
    else if (s.charAt(i) == "}")
      --@@bracesCount;

  return @@bracesCount;
}

function addVariable(s) {
  var re = /(\w+)\s*[^!]?=[^=]/;
  if (!re.exec(s))
    return "";

  if (!shell__vars[RegExp.$1])
    shell__vars[shell__vars.length++] = RegExp.$1;
}

//////////////////////////////////////////////////////////////////////
// Public functions
//////////////////////////////////////////////////////////////////////

function listVariables() {
  setDescription("listVariables", "Show a list of used variables");

  var i = 0;

  for (i = 0; i < shell__vars.length; i++) {
    stdout.write(shell__vars[i] + " contains a(n) " + eval("typeof "+shell__vars[i]) + "\n");
  }

  return "\nDone.";
}

//////////////////////////////////////////////////////////////////////
// Module registration
//////////////////////////////////////////////////////////////////////
addMode("Object", "Object mode, it is the main mode.");
